tbb::flow::interface11::internal::untyped_receiver Class Referenceabstract

`#include <flow_graph.h>`

Inheritance diagram for tbb::flow::interface11::internal::untyped_receiver:
Collaboration diagram for tbb::flow::interface11::internal::untyped_receiver:

## Public Types

typedef untyped_sender | predecessor_type
| The predecessor type for this node. More...

## Public Member Functions

virtual | ~untyped_receiver ()
| Destructor. More...
template<typename X >
bool | try_put (const X &t)
| Put an item to the receiver. More...
virtual bool | register_predecessor (predecessor_type &)
| Add a predecessor to the node. More...
virtual bool | remove_predecessor (predecessor_type &)
| Remove a predecessor from the node. More...

## Protected Member Functions

template<typename X >
task * | try_put_task (const X &t)
virtual task * | try_put_task_wrapper (const void *p, bool is_async)=0
virtual graph & | graph_reference () const =0
virtual void | reset_receiver (reset_flags f=rf_reset_protocol)=0
| put receiver back in initial state More...
virtual bool | is_continue_receiver ()

## Friends

template<typename , typename >
class | run_and_put_task
template<typename , typename >
class | internal::broadcast_cache
template<typename , typename >
class | internal::round_robin_cache
template<typename , typename >
class | internal::successor_cache
template<typename , typename >
class | proxy_dependency_receiver

## Detailed Description

Definition at line 358 of file flow_graph.h.

## Member Typedef Documentation

## predecessor_type

typedef untyped_sender tbb::flow::interface11::internal::untyped_receiver::predecessor_type

The predecessor type for this node.

Definition at line 370 of file flow_graph.h.

## Constructor & Destructor Documentation

## ~untyped_receiver()

virtual tbb::flow::interface11::internal::untyped_receiver::~untyped_receiver | ( |  | ) |

inline virtual

Destructor.

Definition at line 373 of file flow_graph.h.

{}

## Member Function Documentation

## graph_reference()

virtual graph& tbb::flow::interface11::internal::untyped_receiver::graph_reference | ( |  | ) | const

protected pure virtual

Implemented in tbb::flow::interface11::overwrite_node< T >, tbb::flow::interface11::limiter_node< T, DecrementType >, tbb::flow::interface11::buffer_node< T, Allocator >, tbb::flow::interface11::buffer_node< T, __TBB_DEFAULT_NODE_ALLOCATOR(T) >, tbb::flow::interface11::broadcast_node< T >, and tbb::flow::interface11::split_node< TupleType, Allocator >.

Referenced by try_put(), and tbb::flow::interface11::internal::async_helpers< T, typename >::try_put_task_wrapper_impl().

Here is the caller graph for this function:

## is_continue_receiver()

virtual bool tbb::flow::interface11::internal::untyped_receiver::is_continue_receiver | ( |  | ) |

inline protected virtual

Reimplemented in tbb::flow::interface11::continue_receiver.

Definition at line 418 of file flow_graph.h.

{ return false; }

## register_predecessor()

virtual bool tbb::flow::interface11::internal::untyped_receiver::register_predecessor | ( | predecessor_type & |  | ) |

inline virtual

Add a predecessor to the node.

Reimplemented in tbb::flow::interface11::limiter_node< T, DecrementType >, and tbb::flow::interface11::continue_receiver.

Definition at line 389 of file flow_graph.h.

{ return false; }

## remove_predecessor()

virtual bool tbb::flow::interface11::internal::untyped_receiver::remove_predecessor | ( | predecessor_type & |  | ) |

inline virtual

Remove a predecessor from the node.

Reimplemented in tbb::flow::interface11::limiter_node< T, DecrementType >, and tbb::flow::interface11::continue_receiver.

Definition at line 392 of file flow_graph.h.

{ return false; }

## reset_receiver()

virtual void tbb::flow::interface11::internal::untyped_receiver::reset_receiver | ( | reset_flags | f = `rf_reset_protocol` | ) |

protected pure virtual

put receiver back in initial state

Implemented in tbb::flow::interface11::overwrite_node< T >, tbb::flow::interface11::limiter_node< T, DecrementType >, tbb::flow::interface11::buffer_node< T, Allocator >, tbb::flow::interface11::buffer_node< T, __TBB_DEFAULT_NODE_ALLOCATOR(T) >, tbb::flow::interface11::broadcast_node< T >, tbb::flow::interface11::split_node< TupleType, Allocator >, and tbb::flow::interface11::continue_receiver.

## try_put()

template<typename X >

bool tbb::flow::interface11::internal::untyped_receiver::try_put | ( | const X & | t | ) |

inline

Put an item to the receiver.

Definition at line 377 of file flow_graph.h.

{
task *res = try_put_task(t);
if (!res) return false;
if (res != SUCCESSFULLY_ENQUEUED) internal::spawn_in_graph_arena(graph_reference(), *res);
return true;
}
task
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task * task
Definition: ittnotify_static.h:119
tbb::flow::interface11::internal::spawn_in_graph_arena
void spawn_in_graph_arena(tbb::flow::interface10::graph &g, tbb::task &arena_task)
Spawns a task inside graph arena.
Definition: _flow_graph_impl.h:521
tbb::flow::internal::SUCCESSFULLY_ENQUEUED
static tbb::task *const SUCCESSFULLY_ENQUEUED
Definition: _flow_graph_impl.h:61
tbb::flow::interface11::internal::untyped_receiver::try_put_task
task * try_put_task(const X &t)
Definition: flow_graph.h:405
tbb::flow::interface11::internal::untyped_receiver::graph_reference
virtual graph & graph_reference() const =0

References graph_reference(), tbb::flow::interface11::internal::spawn_in_graph_arena(), tbb::flow::internal::SUCCESSFULLY_ENQUEUED, and try_put_task().

Referenced by tbb::flow::interface11::receiver< T >::try_put().

Here is the call graph for this function:
Here is the caller graph for this function:

## try_put_task()

template<typename X >

task* tbb::flow::interface11::internal::untyped_receiver::try_put_task | ( | const X & | t | ) |

inline protected

Definition at line 405 of file flow_graph.h.

{
return try_put_task_wrapper( internal::async_helpers<X>::to_void_ptr(t), internal::async_helpers<X>::is_async_type );
}
tbb::flow::interface11::internal::async_helpers::to_void_ptr
static const void * to_void_ptr(const T &t)
Definition: flow_graph.h:229
tbb::flow::interface11::internal::async_helpers::is_async_type
static const bool is_async_type
Definition: flow_graph.h:227
tbb::flow::interface11::internal::untyped_receiver::try_put_task_wrapper
virtual task * try_put_task_wrapper(const void *p, bool is_async)=0

References try_put_task_wrapper().

Referenced by try_put().

Here is the call graph for this function:
Here is the caller graph for this function:

## try_put_task_wrapper()

virtual task* tbb::flow::interface11::internal::untyped_receiver::try_put_task_wrapper | ( | const void * | p,
|  | bool | is_async
| ) |  |

protected pure virtual

Implemented in tbb::flow::interface11::receiver< T >, tbb::flow::interface11::receiver< TupleType >, tbb::flow::interface11::receiver< continue_msg >, and tbb::flow::interface11::receiver< input_type >.

Referenced by try_put_task().

Here is the caller graph for this function:

## Friends And Related Function Documentation

## internal::broadcast_cache

template<typename , typename >

friend class internal::broadcast_cache

friend

Definition at line 361 of file flow_graph.h.

## internal::round_robin_cache

template<typename , typename >

friend class internal::round_robin_cache

friend

Definition at line 362 of file flow_graph.h.

## internal::successor_cache

template<typename , typename >

friend class internal::successor_cache

friend

Definition at line 363 of file flow_graph.h.

## proxy_dependency_receiver

template<typename , typename >

friend class proxy_dependency_receiver

friend

Definition at line 366 of file flow_graph.h.

## run_and_put_task

template<typename , typename >

friend class run_and_put_task

friend

Definition at line 359 of file flow_graph.h.

The documentation for this class was generated from the following file:

- flow_graph.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.